]> git.pld-linux.org Git - packages/rpm-build-tools.git/blobdiff - builder.sh
- remove some bashizm
[packages/rpm-build-tools.git] / builder.sh
index b322bee8ecc00da9307c0edb52d052c5f1dbc07d..06d0795ae3ccad744d1bfdf3a1e2ca858b09ce9b 100644 (file)
@@ -9,6 +9,7 @@
 #      4 - some source, patch or icon files not stored in repo
 #      5 - package build failed
 #      6 - spec file with errors
+#      7 - wrong source in /etc/poldek.conf
 
 # Notes (todo):
 #      - builder -u fetches current version first
@@ -56,6 +57,7 @@ CHMOD="no"
 CHMOD_MODE="0444"
 RPMOPTS=""
 BCOND=""
+GROUP_BCONDS="no"
 
 PATCHES=""
 SOURCES=""
@@ -92,6 +94,20 @@ else
     RPMBUILD="rpmbuild"
 fi
 
+POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
+POLDEK_SOURCE="cvs"
+
+# Example grep cvs /etc/poldek.conf:
+# source = cvs /home/users/yoshi/rpm/RPMS/
+if [ "$UPDATE_POLDEK_INDEXES" = "yes" ]; then
+       POLDEK_SOURCE_VALIDITY="`grep ${POLDEK_SOURCE} /etc/poldek.conf|grep -v ^#`"
+       if [ "${POLDEK_SOURCE_VALIDITY}" = "" ]; then 
+               echo "Using improper source '${POLDEK_SOURCE}' in /etc/poldek.conf"
+               echo "Fix it and try to contiune"
+               exit 7
+       fi
+fi
+
 if [ -f ~/etc/builderrc ]; then
     . ~/etc/builderrc
 elif [ -f ~/.builderrc ]; then
@@ -139,6 +155,7 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
                        - setup \$CVSROOT,
        --define <macro> <value>
                        - define a macro <macro> with value <value>,
+       --nodeps        - rpm won't check any dependences
        -g, --get       - get <package>.spec and all related files from
                          CVS repo or HTTP/FTP,
        -h, --help      - this message,
@@ -167,6 +184,14 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
        -r <cvstag>, --cvstag <cvstag>
                        - build package using resources from specified CVS
                          tag,
+        -R, --fetch-build-requires
+                        - fetch what is BuildRequired,
+       -RB, --remove-build-requires
+                       - remove all you fetched with -R or --fetch-build-requires
+                         remember, this option requires confirmation,
+       -FRB, --force-remove-build-requires
+                       - remove all you fetched with -R or --fetch-build-requires
+                         remember, this option works without confirmation,
        -T <cvstag> , --tag <cvstag>
                        - add cvs tag <cvstag> for files,
        -Tvs, --tag-version-stable
@@ -189,10 +214,14 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
        -U, --update
                        - refetch sources, don't use distfiles, and update md5 
                          comments
+       -Upi, --update-poldek-indexes 
+                       - refresh or make poldek package index files.
        --with/--without <feature>
                        - conditional build package depending on
                          %_with_<feature>/%_without_<feature> macro
-                         switch
+                         switch. 
+                         You may now use --with feat1 feat2 feat3 --without feat4
+                         feat5 --with feat6 constructions.
 "
 }
 
@@ -210,7 +239,7 @@ cache_rpm_dump () {
 
 rpm_dump () {
     if [ -z "$rpm_dump_cache" ] ; then
-        echo "internal error: cache_rpm_dump not called!" 1>&2
+       echo "internal error: cache_rpm_dump not called!" 1>&2
     fi
     echo "$rpm_dump_cache"
 }
@@ -268,15 +297,19 @@ Exit_error()
 
     case "$1" in
     "err_no_spec_in_cmdl" )
+        remove_build_requires
        echo "ERROR: spec file name not specified.";
        exit 2 ;;
     "err_no_spec_in_repo" )
+        remove_build_requires
        echo "Error: spec file not stored in CVS repo.";
        exit 3 ;;
     "err_no_source_in_repo" )
+        remove_build_requires
        echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
        exit 4 ;;
     "err_build_fail" )
+        remove_build_requires
        echo "Error: package build failed. (${2:-no more info})";
        exit 5 ;;
     esac
@@ -585,6 +618,10 @@ tag_files()
     if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
        echo "Version: $PACKAGE_VERSION"
        echo "Release: $PACKAGE_RELEASE"
+       # Check whether first character of PACKAGE_NAME is legal for tag name
+       if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
+           TAG_PREFIX=tag_
+       fi
        TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
        # Remove #kernel.version_release from TAGVER because tagging sources
        # could occur with different kernel-headers than kernel-headers used at build time.
@@ -603,7 +640,9 @@ tag_files()
 
        cd $SOURCE_DIR
        for i in $TAG_FILES; do
-           if [ -f `nourl $i` ]; then
+           # don't tag non cvs files (ie. stored on distfiles)
+           [ "`nourl $i`" != "$i" ] && continue
+           if [ -f "`nourl $i`" ]; then
                if [ "$TAG_VERSION" = "yes" ]; then
                    cvs $OPTIONS $TAGVER `nourl $i`
                fi
@@ -674,7 +713,7 @@ build_package()
 
     if [ -n "$TRY_UPGRADE" ]; then
 
-       if [ -n "FLOAT_VERSION" ]; then
+       if [ -n "$FLOAT_VERSION" ]; then
            TNOTIFY=`./pldnotify.awk $SPECFILE -n`
        else
            TNOTIFY=`./pldnotify.awk $SPECFILE`
@@ -721,7 +760,7 @@ build_package()
            echo "LASTLOG=$LOG" > $LASTLOG_FILE
        fi
        RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
-       (nice -n ${DEF_NICE_LEVEL} time $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
+       (time nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
        RETVAL=`cat $RES_FILE`
        rm $RES_FILE
        if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
@@ -754,6 +793,177 @@ nourl()
     echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
 }
 
+set_bconds_values()
+{
+AVAIL_BCONDS_WITHOUT=""
+AVAIL_BCONDS_WITH=""
+for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_without_`
+do
+        AVAIL_BCOND_WITHOUT=`echo $opt|sed -e "s/^_without_//g"`
+        if [ "`echo $BCOND|grep -- "--without $AVAIL_BCOND_WITHOUT"`" != "" ];then
+                AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
+        else
+                AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
+        fi
+done
+
+for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_with_`
+do
+        AVAIL_BCOND_WITH=`echo $opt|sed -e "s/^_with_//g"`
+        if [ "`echo $BCOND|grep -- "--with $AVAIL_BCOND_WITH"`" != "" ];then
+                AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
+        else
+                AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
+        fi
+done
+}
+
+remove_build_requires()
+{
+    if [ "$INSTALLED_PACKAGES" != "" ]; then
+           case "$REMOVE_BUILD_REQUIRES" in
+                   "force")
+                       poldek --noask -e $INSTALLED_PACKAGES
+                   ;;
+                   "nice")
+                       poldek --ask -e $INSTALLED_PACKAGES
+                   ;;
+                   *)
+                           echo You may want to manually remove following BuildRequires fetched:
+                           echo $INSTALLED_PACKAGES
+                           echo Try poldek -e \`cat `pwd`/.${SPECFILE}_INSTALLED_PACKAGES\`
+                   ;;
+           esac
+    fi
+}
+
+display_bconds()
+{
+if [ "$AVAIL_BCONDS_WITH" != "" ] || [ "$AVAIL_BCONDS_WITHOUT" != "" ]; then
+        echo -ne "We are going to build $SPECFILE with the following conditional flags:\n"
+        if [ "$BCOND" != "" ]; then
+                echo -ne "$BCOND"
+        else
+                echo -ne "No --with || --without conditions passed to $0!"
+        fi
+        echo -ne "\n\nfrom available:\n\n"
+        echo -ne "--with   :\t$AVAIL_BCONDS_WITH\n--without:\t$AVAIL_BCONDS_WITHOUT\n\n"
+fi
+}
+
+fetch_build_requires()
+{
+if [ "$FETCH_BUILD_REQUIRES" = "yes" ]; then
+           echo -ne "\nAll packages installed by fetch_build_requires() are written to:\n"
+           echo -ne "`pwd`/.${SPECFILE}_INSTALLED_PACKAGES\n"
+           echo -ne "\nIf anything fails, you may get rid of them by executing:\n"
+           echo "poldek -e \`cat `pwd`/.${SPECFILE}_INSTALLED_PACKAGES\`\n\n"
+           echo > `pwd`/.${SPECFILE}_INSTALLED_PACKAGES
+            for package_item in `cat $SPECFILE|grep -B100000 ^%changelog|grep -v ^#|grep BuildRequires|grep -v ^-|sed -e "s/^.*BuildRequires://g"|awk '{print $1}'|sed -e s,\(.*\),,g -e s,%{,,g`
+            do
+               package_item=`echo $package_item|sed -e s,rpmbuild,rpm-build,g`
+                GO="yes"
+                package=`basename "$package_item"|sed -e "s/}$//g"`
+                COND_ARCH_TST="`cat $SPECFILE|grep -B1 BuildRequires|grep -B1 $package|grep ifarch|sed -e "s/^.*ifarch//g"`"
+                mach=`uname -m`
+               
+                COND_TST=`cat $SPECFILE|grep BuildRequires|grep "$package"`
+                if [ "`echo $COND_TST|grep '^BuildRequires:'`" != "" ]; then
+                       if [ "$COND_ARCH_TST" != "" ] && [ "`echo $COND_ARCH_TST|sed -e "s/i.86/ix86/g"`" != "`echo $mach|sed -e "s/i.86/ix86/g"`" ]; then
+                               GO="yes"
+                       fi
+               # bcond:
+               else
+                       COND_NAME=`echo $COND_TST|sed -e s,:BuildRequires:.*$,,g`
+                       GO=""
+                       # %{without}
+                       if [ "`echo $COND_TST|grep 'without_'`" != "" ]; then
+                               COND_NAME=`echo $COND_NAME|sed -e s,^.*_without_,,g`
+                               if [ "`echo $COND_TST|grep !`" != "" ]; then
+                                       COND_STATE="with"
+                               else
+                                       COND_STATE="wout"
+                               fi
+                               if [ "`echo $AVAIL_BCONDS_WITHOUT|grep "<$COND_NAME>"`" != "" ]; then
+                                       COND_ARGV="wout"
+                               else
+                                       COND_ARGV="with"
+                               fi
+                       # %{with}
+                       elif [ "`echo $COND_TST|grep 'with_'`" != "" ]; then
+                               COND_NAME=`echo $COND_NAME|sed -e s,^.*_with_,,g`
+                               if [ "`echo $COND_TST|grep !`" != "" ]; then
+                                       COND_STATE="wout"
+                               else
+                                       COND_STATE="with"
+                               fi                                      
+                               if [ "`echo $AVAIL_BCONDS_WITH|grep "<$COND_NAME>"`" != "" ]; then
+                                       COND_ARGV="with"
+                               else
+                                       COND_ARGV="wout"
+                               fi      
+                       fi
+                       RESULT="${COND_STATE}-${COND_ARGV}"
+                       case "$RESULT" in 
+                               "with-wout" | "wout-with" )
+                                       GO=""
+                                       ;;
+                               "wout-wout" | "with-with" )
+                                       GO="yes"
+                                       ;;
+                               * )
+                                       echo "Action '$RESULT' was not defined for package '$package_item'"
+                                       ;;
+                       esac
+
+                fi
+              
+                if [ "$GO" = "yes" ]; then
+                        if [ "`rpm -q $package|sed -e "s/$package.*/$package/g"`" != "$package" ]; then
+                                echo "Testing if $package has subrequirements..."
+                               poldek -t -i $package --dumpn=".$package-req.txt"
+                               for package_name in `cat ".$package-req.txt"|grep -v ^#`
+                               do 
+                                       if [ "$package_name" = "$package" ]; then
+                                               echo -ne "Installing BuildRequired package:\t$package_name\n"
+                                               poldek -i $package_name
+                                       else
+                                               echo -ne "Installing (sub)Required package:\t$package_name\n"
+                                               poldek -i $package_name
+                                       fi
+                                       case $? in
+                                       1)
+                                               echo -ne "Package installation failed:\t$package_name\n"
+                                               #
+                                               # No i tutaj bym chcia³ zrobiæ sztuczn± inteligencjê, która spróbuje tego
+                                               # pakieta zbudowaæ. 
+                                               #
+                                               NOT_INSTALLED_PACKAGES="$NOT_INSTALLED_PACKAGES $package_name"
+                                               ;;
+                                       0)
+                                               INSTALLED_PACKAGES="$package_name $INSTALLED_PACKAGES"
+                                               echo $package_name >> `pwd`/.${SPECFILE}_INSTALLED_PACKAGES
+                                               ;;
+                                       esac
+                               done
+                               rm ".$package-req.txt"
+                        else
+                                echo "Package $package is already installed. BuildRequirement satisfied."
+                        fi
+                fi
+            done
+            if [ "$NOT_INSTALLED_PACKAGES" != "" ]; then
+                    echo "Nie uda³o siê zainstalowaæ nastêpuj±cych pakietów i ich zale¿no¶ci:"
+                    for pkg in "$NOT_INSTALLED_PACKAGES"
+                    do
+                            echo $pkg
+                    done
+                   remove_build_requires
+                    exit 1
+            fi
+fi
+}
+
 #---------------------------------------------
 # main()
 
@@ -825,13 +1035,36 @@ while test $# -gt 0 ; do
        --opts )
            shift; RPMOPTS="${1}"; shift ;;
        --with | --without )
-           BCOND="$BCOND $1 $2" ; shift 2 ;;
+           case $GROUP_BCONDS in
+               "yes")
+                       COND=${1}
+                       shift
+                       while [ "`echo ${1}|grep ^-`" = "" ] && [ "`echo ${1}|grep spec`" = "" ]
+                       do
+                               BCOND="$BCOND $COND $1"
+                               shift
+                       done;;
+               "no")
+                       BCOND="$BCOND $1 $2" ; shift 2 ;;
+           esac
+           ;;
        -q | --quiet )
            QUIET="--quiet"; shift ;;
        --date )
            CVSDATE="${2}"; shift 2 ;;
        -r | --cvstag )
            shift; CVSTAG="${1}"; shift ;;
+        -R | --fetch-build-requires)
+            FETCH_BUILD_REQUIRES="yes"
+           #UPDATE_POLDEK_INDEXES="yes"
+            NOT_INSTALLED_PACKAGES=
+            shift ;;
+        -RB | --remove-build-requires)
+            REMOVE_BUILD_REQUIRES="nice"
+           shift ;;
+       -FRB | --force-remove-build-requires)
+           REMOVE_BUILD_REQUIRES="force"
+           shift ;;
        -Tvs | --tag-version-stable )
            COMMAND="tag";
            TAG="STABLE"
@@ -873,6 +1106,9 @@ while test $# -gt 0 ; do
            NODIST="yes"
            UPDATE5="yes"
            shift ;;
+       -Upi | --update-poldek-indexes )
+           UPDATE_POLDEK_INDEXES="yes"
+           shift ;;
        -u | --try-upgrade )
            TRY_UPGRADE="1"; shift ;;
        -un | --try-upgrade-with-float-version )
@@ -886,6 +1122,10 @@ while test $# -gt 0 ; do
            shift 2
            RPMOPTS="${RPMOPTS} --define \"${MACRO} ${VALUE}\""
            ;;
+       --nodeps)
+           shift
+           RPMOPTS="${RPMOPTS} --nodeps"
+           ;;
        * )
            SPECFILE="`basename ${1} .spec`.spec"; shift ;;
     esac
@@ -901,6 +1141,9 @@ case "$COMMAND" in
        init_builder;
        if [ -n "$SPECFILE" ]; then
            get_spec;
+           set_bconds_values;
+            display_bconds;
+            fetch_build_requires;
            parse_spec;
 
            if [ -n "$FAIL_IF_CHANGED_BUT_NOT_BUMPED" ]; then
@@ -922,6 +1165,11 @@ case "$COMMAND" in
            fi
            get_files "$SOURCES $PATCHES";
            build_package;
+           if [ "$UPDATE_POLDEK_INDEXES" = "yes" ]; then
+                   poldek --sn ${POLDEK_SOURCE} --mkidx="${POLDEK_INDEX_DIR}/packages.dir.gz"
+                   poldek --sn ${POLDEK_SOURCE} --up
+           fi
+           remove_build_requires;
        else
            Exit_error err_no_spec_in_cmdl;
        fi
@@ -967,6 +1215,13 @@ case "$COMMAND" in
                get_files $ICONS
                parse_spec;
            fi
+           # don't fetch sources from remote locations
+           new_SOURCES=""
+           for file in $SOURCES; do
+               [ "`nourl $file`" != "$file" ] && continue
+               new_SOURCES="$new_SOURCES $file"
+           done
+           SOURCES="$new_SOURCES"
            get_files $SOURCES $PATCHES;
            tag_files "$SOURCES $PATCHES $ICONS";
        else
@@ -981,5 +1236,4 @@ case "$COMMAND" in
     "version" )
        echo "$VERSION";;
 esac
-
 cd $__PWD
This page took 0.052648 seconds and 4 git commands to generate.